<?php

namespace App\Console\Commands\Ynv;

use Carbon\Carbon;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;

class YnvCommand extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'ynv:get-track {page_index?}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $page_index = $this->argument('page_index');
        $page_index = intval($page_index);

        echo "\n Starting...";

        $results = [];
        $domain = 'http://www.yeunhacvang.com/';
        //$page_index = 34;
        //for ($page = 1; $page <= 140; $page++) {
        for ($page = $page_index; $page <= $page_index; $page++) {
            echo "\n - Processing page " . $page;

            $title = [];
            $link = [];
            $singer = [];

            $url = $domain . '?pg=list&page='.$page;
            $dom = getDom($url);

            /* Lấy tên bài hát */
            $element_track_title = 'div.main table#table1 tr td a';
            foreach ($dom->find($element_track_title) as $data) {
                $title[] = str_replace([], [], $data->innertext);
            }

            /* Lấy link bài hát */
            $element_track_title = 'div.main table#table1 tr td a';
            foreach ($dom->find($element_track_title) as $data) {
                $link[] = $domain . str_replace([], [], $data->href);
            }

            /* Lấy tên ca sĩ */
            $element_track_title = 'div.main table#table1 tr td';
            foreach ($dom->find($element_track_title) as $data) {
                if ($data->width == "40%") {
                    $singer[] = str_replace([], [], $data->innertext);
                }
            }

            echo "\n -> Số bài " . count($title);

            for ($i=0; $i < count($title); $i++) {
                preg_match("/-([0-9]+)$/", $link[$i], $ids);
                $results[] = [
                    'page_index' => $page_index,
                    'track_id' => (is_array($ids) && count($ids) == 2) ? $ids[1] : null,
                    'title' => $title[$i],
                    'singer' => $singer[$i+1],
                    'detail_link' => $link[$i],
                    'is_checking' => 0,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now()
                ];
            }
        }

        //print_r($results);

        if (count($results) > 0) {
            DB::table('ynvs')->insert($results);
        }

        echo "\n Done.";
    }
}
